package oauthprovider_admin

import (
	"context"
	"git.noahlan.cn/n-admin/n-admin-server/rpc/core/types/core"
	"github.com/jinzhu/copier"

	"git.noahlan.cn/n-admin/n-admin-server/api/internal/svc"
	"git.noahlan.cn/n-admin/n-admin-server/api/internal/types"

	"net/http"
)

type UpdateOauthProviderAdminLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	r      *http.Request
}

func NewUpdateOauthProviderAdminLogic(r *http.Request, ctx context.Context, svcCtx *svc.ServiceContext) *UpdateOauthProviderAdminLogic {
	return &UpdateOauthProviderAdminLogic{
		r:      r,
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UpdateOauthProviderAdminLogic) UpdateOauthProviderAdmin(req *types.OauthProviderInfo) error {
	var rpcReq core.OauthProviderInfo
	_ = copier.Copy(&rpcReq, req)
	rpcReq.Init = true

	_, err := l.svcCtx.CoreRpc.UpdateOauthProvider(l.ctx, &rpcReq)
	if err != nil {
		return err
	}

	return nil
}
